Tento manuál se vzathuje ke Speech Dispatcher, verze 0.8.6.  Jedná se
však pouze o uživatelskou část dokumentace a upozorňujeme, že tento
překlad již není aktuální!  Poskytujeme jej s tím, že možná bude
užitečný a to zejména v sekcích, které popisují obecné koncepty a
myšlenky projektu, a to těm, kteří si nemohou přečíst anglickou
dokumentaci.  Nikdo by nicméně neměl spoléhat na technické detaily zde
uvedené, protože mnoho věcí je již dnes jinak.

   Copyright (C) 2001, 2002, 2003 Brailcom, o.p.s.

     Dáváme povolení kopírovat, distribuovat a/nebo modifikovate tento
     dokument pod podmínkami GNU Free Documentation License, Verze 1.2
     nebo jakékoliv novější verze vydané Free Software Foundation; bez
     jakýchkoliv Invariant Sections (neměnných sekcí), bez Front-Cover
     Texts (texty na přední straně obálky) a bez Back-Cover Texts (texty
     na zadní straně obálky).  Kopie této licence je přiložena v sekci
     nazvané ,,GNU Free Documentation License".

1 Úvod
******

1.1 Motivace
============

Projekt Speech Dispatcher se snaží poskytnout na zařízení nezávislou
vrstvu pro řečovou syntézu.  Měl by poskytovat jednoduché rozhraní pro
klientské aplikace (aplikace, které chtějí mluvit), stejně jako pro
ovladače konkrétních zařízení (různé řečové syntetizéry).

   Vysoce kvalitní řečová syntéza je tu již dlouho a nyní je použitelná
i pro běžné uživatele na jejich domácích počítačích.  Občas to přichází
jako nutnost, občas je to jen dobrá vlastnost, aby některé programy
poskytovaly řečový výstup.  Pro syntézu hlasu je tu široké pole využití
od výukového software až po specializované systémy, jako jsou například
nemocnice či laboratoře.  Pro zrakově postižené uživatele je to jedna ze
dvou základních cest, jak získat výstup z počítače (tou druhou je
Braillský řádek).

   Existují různé řečové syntetizéry s různými schopnostmi.  Některé z
nich jsou hardwarové, některé softwarové.  Některé jsou svobodným
software a jsou volně dostupné na internetu.  Programátoři to mají
opravdu těžké, když chtějí své programy rozmluvit, protože potřebují
nejprve najít nějaký vhodný syntetizér (dlouhé hodiny experimentování a
tak dále) a potom jej potřebují nějak zprovoznit s jejich programem.
Často musí psát pro tyto programy či hardwarová zařízení vlastní
ovladače a dělají to znovu a znovu.  Snadno si lze představit, že se to
celé zhroutí když nevinný uživatel spustí dva programy najednou.  Kdyby
přesto nastartovaly oba, budou křičet jeden přes druhého.

   Tím je pro programátory velmi obtížné implementovat do svých programů
podporu řečové syntézy (pro nevidomé uživatele, nebo prostě pro lepší
uživatelské rozhraní) a je to jeden z důvodů, proč pořád ještě plně
nevyužíváme toho, co řečová syntéza nabízí.

   V ideálním světě by programátoři mohli pro řečovou syntézu používat
podobné příkazy, jako to dělají pro textový výstup na obrazovku (printf,
puts, ...).  V ideálním světě by existovalo nějaké speech_printf(),
které by se staralo o to, aby byla zpráva přemluvena ve správný čas bez
přerušování ostatních.  Programátor by se tak nemusel starat o to, jak
je přesně komunikace s řečovým syntetizérem implementována.  V ideálním
světě by byl v každé GNU/Linuxové distribuci nějaký řečový syntetizér a
nějaké rozhraní starající se o aplikace, které chtějí mluvit, dovolující
uživatelům nastavit si parametry řeči a poskytující nějaké jednoduché
rozhraní (jako speech_printf()) pomocí nějaké sdílené knihovny pro
programátory.  Bude to jěště dlouhá cesta než se nám podaří dosáhnout
tohoto stavu věcí, ale se Speech Dispatcherem děláme první krůčky...

1.2 Základní design
===================

V komunikaci mezi všemi různými aplikacemi a syntetizéry je obrovský
nepořádek.  Proto jsme chtěli, aby byl Speech Dispatcher vrstva
oddělující aplikace a syntetizéry tak, aby se aplikace nemusely starat o
syntetizéry a syntetizéry se nemusely starat o interakci s aplikacemi.

   Rozhodli jsme se implementovat Speech Dispatcher jako server, který
přijímá od aplikací příkazy přes protokol nazvaný 'SSIP', zpracovává je
a, pokud je to nutné, zavolá příslušnou funkci daného výstupního modulu,
který pak komunikuje s některým z různých syntetizátorů.

   Každý klient (aplikace, která chce mluvit) otevře socketové spojení
na Speech Dispatcher a volá funkce jako say(), stop(), pause()
poskytované knihovnou implementující tento protokol.  Tato sdílená
knihovna je stále na straně klienta a posílá Speech Dispatcheru SSIP
příkazy přes otevřený socket.  Když příkazy dorazí do Dispatchera, ten
je zpracuje, přečte text, který by měl být přeříkán a vloží jej do
fronty podle jeho priority.  Potom se rozhodne kdy, s jakými parametry
(nastavovanými klientským programem i uživatelem) a na jakém syntetizéru
zprávu nechá přemluvit.  Tyto požadavky na mluvení jsou pak zpracovávány
výstupními moduly (pluginy) pro různé hardwarové a softwarové
syntetizéry a přeříkány nahlas.

   Detailní popis programování klientů i serveru je k dispozici v
anglickém manuálu.

1.3 Přehled základních rysů
===========================

Speech Dispatcher z pohledu uživatele:

   * snadná konfigurace různých mluvících aplikací, centrální správa
   * možnost volně rozhodovat, jaká aplikace bude mluvit s jakým
     syntetizérem
   * méně času věnovaného konfiguraci a ladění různých aplikací
     využívajících syntézu
   * historie zpráv pro zrakově postižené uživatele

   Speech Dispatcher z pohledu programátora aplikace:

   * snadná cesta, jak aplikaci rozmluvit
   * jednotné rozhraní k různým syntetizérům
   * synchronizace zpráv na vyšší úrovni (kategorizace pomocí priorit)
   * možnost nemuset se starat o konfiguraci parametrů hlasu

1.4 Současný stav
=================

TODO:

2 Uživatelská dokumentace
*************************

2.1 Základní funkce
===================

V této sekci je detailnější popis základních funkcí Speech Dispatcheru.

2.1.1 Model priorit zpráv
-------------------------

Speech Dispatcher nemůže syntetizovat všechny zprávy, které do něj
přichází z prostého důvodu, že zprávy přicházejí obyčejně rychleji, než
je syntetický hlas dokáže číst.  Na obrazovce monitoru je v porovnání s
jednokanálovým řečovým výstupem relativně hodně místa.  Z toho důvodu
používáme systém několika priorit zaměřených na různé typy zpráv.

   Myšlenka je taková, že úlohou programátora klientské aplikace bude
pouze určit pro každou zprávu určitou prioritu odpovídající typu dané
zprávy.  Veškerá synchronizace a přepínání mezi těmito zprávami (které
mohou pocházet od různých klientů) potom bude zajištěno aplikováním
určitých pravidel ve Speech Dispatcheru.

2.1.1.1 Priority Categories
...........................

Speech Dispatcher poskytuje systém pěti priorit.  Každá zpráva obsahuje
buď explicitní informaci o prioritě, nebo jí je přiřazena výchozí
priorita.

   Prosím podívejte se také na přiložený diagram (dole).

Priorita 'important'
....................

Tato zpráva bude přeříkána okamžitě, jak dorazí do serveru.  Není nikdy
přerušena.  Když server obdrží současně několik různých zpráv této
priority, ty jsou uloženy a přeříkány v pořadí, ve kterém přišly.

   Když přijde nová zpráva priority 'important' a zrovna se říká nějaká
jiná zpráva, tato jiná zpráva je zahozena.  Další zprávy nižších priorit
jsou buď pozdrženy (priorita 'message' a 'text') než již nečekají na
přeříkání žádné zprávy priority 'important', nebo jsou zahozeny
(priority 'notification' a 'progress').

   Tyto zprávy by měly být tak krátké, jak je to jen možné, a měly by
být používány pouze zřídka, protože blokují výstup všech ostatních
zpráv.

Priorita 'message'
..................

Tato zpráva bude přeříkána, pokud již ve frontě nečeká žádná jiná zpráva
priority 'important' nebo 'message'.  V opačném případě je tato zpráva
pozdržena dokud nebudou všechny přeříkány.  To znamená, že priorita
'message' nezastavuje sama sebe.  Když ve frontě čekají zprávy priorit
'notification' nebo 'progress' nebo 'text' když přijde zpráva priority
'message', jsou zahozeny.

Priorita 'text'
...............

Tato zpráva bude přeříkána, když ve frontě nečeká žádná zpráva priority
'important' nebo 'message'.  Pokud čeká, tato nová zpráva je pozdržena
dokud nebudou předchozí zprávy přeříkány.

   Priorita text přerqušuje sama sebe.  To znamená, že když přijde
několik zpráv priority text, ty nejsou přeříkány v pořadí, ve kterém
přišly, ale bude vyřčena pouze poslední z nich a ostatní jsou přerušeny
a zahozeny.

   Pokud jsou ve frontě zprávy priorit 'notification' nebo 'progress'
nebo se právě přeříkávají, jsou zahozeny.

Priorita 'notification'
.......................

Toto je zpráva nízké priority.  Pokud ve frontě čekají zprávy priorit
'important', 'messages', 'text' nebo 'progress' nebo jsou právě
přeříkávány, tato nová zpráva priority 'notification' je zrušena.

   Tato priorita přerušuje sama sebe, takže když přijde najednou více
zpráv s prioritou 'notification', přeříká se pouze poslední z nich.

Priority 'progress'
...................

Toto je speciální priorita pro zprávy, které přicházejí krátce po sobě a
nesou informaci o nějaké probíhající činnosti (např. 'Dokončeno 45%').

   Kdyby nové zprávy přerušovaly ostatní (viz.  priorita Notification),
uživatel by nemusel slyšet ani jednu zprávu do konce.

   Tato priorita se chová stejně jako 'notification' s výjimkou dvou
věcí.

   * Zprávy této priority nepřerušují jedna druhou.  Místo toho, pokud
     je zrovna přeříkávána jiná zpráva této priority, nově příchozí
     zpráva je zahozena.
   * Speech Dispatcher se snaží detekovat poslední zprávu v sérii
     příchozích zpráv a zaručit její přeříkání (pro uživatele je
     důležité slyšet zprávu 'Completed 100%', aby věděl, že proces již
     skončil).  Vždy, když ve frontě již nečeká žádná nová zpráva této
     priority a poslední příchozí zpráva ještě nebyla přeříkána, je její
     přeříkání vynuceno s prioritou 'message'.

2.1.1.2 Diagram priorit
.......................

2.1.1.3 Příklady využití priorit
................................

Příklady použití priority 'important' jsou:

   * chybové hlášky
   * velmi důležité zprávy
   * ...

   Příklady použití priority 'message' jsou:

   * běžné zprávy programu
   * varování
   * ...

   Příklady použití priority 'text' jsou:

   * text, na kterém uživatel pracuje
   * předčítaný text
   * položky menu
   * ...

   Příklady použití priority 'notification' jsou:

   * méně důležité informace
   * písmenka při vkládání
   * run-time nápověda
   * ...

   Příklady použití priority 'progress' jsou:

   * "dokončeno 15%", "dokončeno 16%", "dokončeno 17%"
   * "Načítám zvuky", "Načítám grafiku", "Načítám ai", ...

2.1.2 Historie zpráv
--------------------

Pro nevidomé a zrakově postižené je dobrou vlastností, pokud mají
možnost nějakým jednoduchým klientem procházet historii vyslovených
zpráv.

   Některé méně důležité zprávy jsou přijmuty Speech Dispatcherem bez
toho, aby byly přeříkány, protože jsou potlačeny důležitějšími
informacemi.  To je nedělitelná vlastnost každého řečového rozhraní,
protože není možné podat v řečovém výstupu tolik informací, kolik se
jich vejde na obrazovku.  To je jeden z hlavních důvodů, proč je výhodné
udržovat historii přijatých zpráv, aby se mohl uživatel podívat, zda mu
neušlo něco důležitého.

2.1.2.1 Access Rights
.....................

Aby bylo ochráněno soukromí uživatelů, Speech Dispatcher omezuje přístup
k historii na určitou podmnožinu přijatých zpráv.  Platí následující
pravidla:

   * Všechny zprávy přijaté od určitého klientského spojení jsou tomuto
     spojení přístupny i v historii.

   * Všechny zprávy odeslané určitým uživatelem jsou tomuto uživateli
     přístupny i v historii.

   * Všechny zprávy zaslané uživatelem 'speechd' jsou přístupny všem
     uživatelům na daném systému, pod kterým běží Speech Dispatcher ve
     skupině 'speechd'.

   * Žádné další zprávy nejsou přístupné.

   Dvě zprávy jsou považovány za identické jestliže jejich spojení
pocházejí z toho samého počítače, uživatelská jména jsou stejná a jejich
identita může být ověřena, jak je popsáno v Autentifikace uživatelů.
Pokud nemůže být uživatelova identita ověřena, tento
uživatel je považován za jiného než všichni připojení nebo dříve
připojení uživatelé.

2.1.3 Více výstupních modulů
----------------------------

Speech Dispatcher podporuje souběžné používání více výstupních modulů.
Pokud tyto moduly poskytují dobrou synchronizaci, lze je při čtení zpráv
kombinovat.  Pokud např.  modul1 mluví anglicky a česky, zatímco modul2
mluví pouze německy, tak pokud přijde nějaká zpráva v němčině, použije
se modul2, zatímco pro ostatní jazyky se použije modul1.  Na druhé
straně jazyk není jediným kritériem pro takové rozhodnutí.  Přesná
pravidla pro výběr výstupího modulu mohou být ovlivněna v konfiguračním
souboru 'speechd.conf'.

2.1.4 Autentifikace uživatelů
-----------------------------

NOTE: Na implementaci této vlastnosti se pracuje, ale současná verze ji
nepodporuje.

   Speech Dispatcher neposkytuje žádný explicitní autentifikační
mechanismus.  K ověření identity uživatlů používáme Identification
Protocol definovaný v RFC 1413.

   V konfiguraci je možné specifikovat mapování uživatelů.  To umožňuje
jednat s určitými uživateli jako s jedním a přidělit jim stejná práva
(např.  procházet jejich Historie zpráv).

2.2 Invoking
============

2.2.1 Potřebná privilegia
-------------------------

Speech Dispatcher může být obecně spouštěn pod obyčejným uživatelem.
Snažili jsme se jej zabezpečit, jak jen to bylo možné, ale nejsme
odborníky na počítačovou bezpečnost a kód může obsahovat nebezpečné
chyby.  Nedoporučujeme jej spouštět jako root nebo pod jiným vysoce
privilegovaným uživatelem.

   Jediná omezení jsou tyto:

   * Speech Dispatcher vytváří PID file standardně ve
     '/var/run/speech-dispatcher.pid', takže '/var/run/' musí být danému
     uživateli přístupné k zápisu.  To může být změněno nastavením volby
     'pidpath' při volání skriptu './configure' při kompilaci.
   * Když je zapnuto logování, výchozí cesta, kam Speech Dispatcher
     zapisuje svůj log, je '/var/log/speech-dispatcher.log'.  To ale
     může být kdykoliv přenastaveno v hlavním konfiguračním souboru.

2.2.2 Volby příkazové řádky
---------------------------

Speech Dispatcher může být spuštěn s těmito volbami:

   'speech-dispatcher [-{d|s}] [-l {1|2|3|4|5}] [-p=port] | [-v] | [-h]'

'-d or --run-daemon'
     Spustí program jako démona (běží v pozadí, odpojí se od terminálu,
     atd.)  Toto je výchozí chování.

'-s or --run-single'
     Spustí program jako běžnou aplikaci běžící na popředí.

'-l level or --log-level=level'
     Vybere požadovaný logovací úroveň.  Logovací úroveň je číslo mezi 0
     a 5 (0 znamená neloguj nic, 5 znamená zapisuj téměř vše včetně
     zpracovávaného textu.)  Standardní je 3.  See Úrovně logování.

     Logovací úroveň 5 by neměla být používána k jiným účelům, než pro
     hledání chyb a to pouze krátkodobě.  Logy, které produkuje mohou
     narůst do obrovské velikosti a obsahují text čtený uživateli
     nezávisle na různých přístupových právech, jak platí pro historii.
     Spouštět server s touto úrovní logování tedy může snadno vést k
     narušení soukromí.

'-p or --port'
     Zadá port, na kterém by měl server čekat na klienty.  Výchozí je
     6560.

'-v or --version'
     Vypíše informace o verzi Speech Dispatchera.  Také oznámí základní
     informace o copyrightu.

'-h or --help'
     Vypíše nápovědu o volbách příkazové řádky, upozornění o copyrightu
     a emailovou adresu pro zasílání oznámení o chybách.

2.3 konfigurace
===============

Speech Dispatcher může být konfigurován na několika různých úrovních.
Jedna z nich je nastavování globálních parametrů přes serverový
konfigurační soubor.  Je zde i podpora pro konfiguraci specifickou pro
určité klienty.

   Některé aplikace mají vlastní mechanismus nastavování voleb
souvisejících s řečovou syntézou.  Pro detaily o těchto nastaveních se
prosím podívejte do dokumentace daného programu.

   Následující kapitoly se zabývají pouze konfigurací na straně serveru
přes konfigurační soubor.

2.3.1 Syntaxe konfiguračního souboru
------------------------------------

Pro načítání configurace založené na textových souborech používáme
knihovnu DotConf, takže bude syntaxe nejspíš mnoha uživatelům povědomá.

   Každá z řetězcových konstant, pokud není uvedeno jinak, by měla být
zakódována v UTF-8.  Jména voleb nepoužívají jiné znaky než standardní
ASCII sadu omezenou na znaky ('a', 'b', ...), pomlčky ('-') a podtržítka
'_'.

   Komentáře a dočasně neaktivní volby začínají znakem '#'.  Pokud
chcete takovu volbu zapnout, stačí smazat znak komentáře a nastavit
volbu na požadovanou hodnotu.
     # toto je komentar
     # InactiveOption "tato volba je zatim vypla komentarem"

   Řetězce jsou uzavřeny v uvozovkách.
     LogFile  "/var/log/speech-dispatcher.log"

   Čísla jsou zapsána bez uvozovek.
     Port 6560

   Přepínače používají On (zapnuto) a Off (vypnuto).
     Debug Off

2.3.2 Configuration options
---------------------------

Všechny dostupné volby jsou zdokumentovány přímo v konfiguračním souboru
a jsou k nim uvedeny i příklady.  Většina voleb je nastavena na výchozí
hodnotu a zakomentována.  Pokud je chcete změnit, postačí modifikovat
jejich hodnotu a smazat symbol komentáře '#'.

2.3.3 Output Modules Configuration
----------------------------------

Každý uživatel by si měl zapnout ve své konfiguraci alespoň jeden
výstupní modul, pokud chce, aby Speech Dispatcher produkoval nějaký
zvukový výstup.  Když není načten žádný výstupní modul, Speech
Dispatcher sice nastartuje, bude komunikovat s klienty a logovat zprávy
do historie, ale nebude produkovat žádný zvuk.

   Každý výstupní modul je třeba do Speech Dispatchera natáhnout jednou
řádkou "AddModule" v 'etc/speechd.conf'.  Navíc, každý výstupní modul má
přiřazen vlastní konfigurační soubor.

2.3.3.1 Natahování modulů ve speechd.conf
.........................................

Každý modul, který by se měl spustit při startu Speech Dispatchera, musí
být natažen příkazem 'AddModule' v konfiguraci.  Všimněte si, že lze
natáhnout jeden binární modul vícekrát s různými konfiguračními soubory
a pod jinými jmény.  To je užitečné hlavně pro natahování generických
výstupních modulů.  See Konfigurace generického výstupního modulu.

     AddModule "MODULE_NAME" "MODULE_BINARY" "MODULE_CONFIG"

   MODULE_NAME je jméno daného výstupního modulu.

   MODULE_BINARY je jméno binárního spustitelného souboru tohoto
výstupního modulu.  To může být buď cesta absolutní nebo relativní k
'bin/speechd-modules/'.

   MODULE_CONFIG je soubor s konfigurací pro tento konkrétní výstupní
modul.  Cesta může být absolutní i relativní k
'etc/speech-dispatcher/modules/'.  Tento parametr je volitelný (není
třeba jej uvádět).

2.3.3.2 Konfigurační soubory výstupních modulů
..............................................

Každý výstupní modul je odlišný a proto má odlišné volby v konfiguraci.
Prosím prostudujte si komentáře v daném konfiguračním souboru.  Zde je
popsáno pouze několik voleb, které jsou pro některé výstupní moduly
společné.

'AddVoice "LANGUAGE" "SYMBOLICNAME" "NAME"'

     Každý výstupní modul poskytuje nějaké hlasy a někdy dokonce
     podporuje různé jazyky.  Z toho důvodu byl zaveden společný
     mechanismus, kterým můžou být tyto hlasy definovány v konfiguraci.
     Žádný modul ovšem není povinen tuto volbu používat.  Některé
     syntetizátory, např.  Festival, podporují symbolická jména SSIP
     přímo, takže konfigurace konkrétních hlasů se provádí v
     syntetizátoru samotném.

     Každému definovanému hlasu odpovídá přesně jedna řádka 'AddVoice'.

     LANGUAGE je ISO kód jazyka tohoto hlasu (en, cs, de, ...)

     SYMBOLICNAME je symbolické jméno, pod kterým chcete, aby byl tento
     hlas dostupný.  See Standardní hlasy, pro seznam symbolických
     jmen, která můžete použít.

     NAME je jméno specifické pro daný výstupní modul.  Prosím podívejte
     se na komentáře v příslušném konfiguračním souboru v sekci
     AddModule pro detailnější informace.

     Např.  definice, kterou v součastnosti používáme pro Epos (generic)
     vypadá takto:

                  AddVoice        "cs"  "male1"   "kadlec"
                  AddVoice        "sk"  "male1"   "bob"

'ModuleDelimiters "DELIMITERS", ModuleMaxChunkLength LENGTH'

     Často se výstupní modul nesnaží vysyntetizovat celý příchozí text
     najednou, ale místo toho jej nejprve rozřeže na menší kousky (věty,
     části vět) a ty potom postupně odesílá na syntézu.  Tento přístup,
     využívaný některými výstupními moduly, je mnohem rychlejší, ale na
     druhé straně zase limituje schopnost syntetizéru poskytnout dobrou
     intonaci.

     Z toho důvodu máte obyčejně možnost zkonfigurovat si na jakých
     znacích (DELIMITERS) by se měl text rozdělit na menší části (pokud
     jsou následovány nějakým whitespace znakem).  Druhá volba (LENGTH)
     udává, po kolika znacích by se měl text násilně rozdělit, pokud
     nebyl nalezen žádný delimiter.

     Pokud tato dvě pravidla zpřísníte, dostanete lepší rychlost, ale
     vzdáte se určité části kvality intonace.  Takže například pro
     pomalejší počítače doporučujeme do DELIMITERS vložit i čárku (,),
     aby byl text rozdělen i na částech věty, zatímco na rychlejších
     počítačích je lepší tam čárku nedávat, takže do syntetizéru vždy
     dorazí celá souvětí.

     To samé platí o 'MaxChunkLength'.  Pro rychlejší počítače je lepší
     nastavit větší hodnotu.

     Například výchozí hodnoty ve výstupním modulu pro Festival jsou:

              FestivalMaxChunkLength  300
              FestivalDelimiters  ".?!;,:"

     Výstupní modul se může také rozhodnout dělit věty na delimiters
     pouze pokud ty jsou následovány mezerou.  Takže například
     "file123.tmp" by rozděleno nebylo, ale věta "The horse raced around
     the fence, that was lately painted green, fell."  by rozdělena byla
     (to je mimochodem velmi zajímavá věta).

2.3.3.3 Konfigurace generického výstupního modulu
.................................................

Generický výstupní modul uživatelům dovoluje jednoduše si napsat vlastní
jednoduchý výstupní modul pro syntetizéry, které mají rozhraní ve formě
jednoduchého řádkového klienta, pouze modifikací konfiguračního souboru.
Tímto způsobem nemusí psát žádný specifický kód v C a uživatelé si mohou
přidávat podporu pro výstupní zařízení i když neumí programovat.  See
AddModule.

   Klíčová část každého generického výstupního modulu je definice
řetězce, který se má spouštět.

 -- Konfigurace generického modulu: GenericExecuteSynth
          "EXECUTION_STRING"

     'execution_string' je příkaz, který by měl být zavolán v shellu,
     když je potřeba něco říct.  Ve skutečnosti to může být více jak
     jeden příkaz, dohromady zřetězené operátorem '&&'.  Když bude
     výstupní modul chtít přeříkávání zprávy zastavit, zašle těmto
     procesům signál KILL, takže je důležité, aby použité příkazy po
     obdržení KILL okamžitě přestaly mluvit.  (Na většině GNU/Linuxových
     systémů má tuto vlastnost utilita 'play')

     V 'execution_string' můžete využít těchto proměnných, které budou
     nahrazeny pořadovanými hodnotami, než bude příkaz vykonán.

        * '$DATA' Text, který by měl být přeříkán.  Znaky řetězce, které
          by nějak interferovali se zpracováním v bashi budou
          automaticky nahrazeny odpovídajícími escape sekvencemi.  Asi
          bude ale nutné uvést kolem této proměnné uvozovky (např.
          takto: '\"$DATA\"').
        * '$LANG' Identifikační řetězec jazyka (ten je definován pomocí
          GenericLanguage).
        * '$VOICE' Identifikační řetězec hlasu (ten je definován pomocí
          AddVoice).
        * '$PITCH' Požadovaná výška hlasu (desetinné číslo definované v
          GenericPitchAdd a v GenericPitchMultiply)
        * '$RATE' Požadovaná rychlost hlasu (desetinné číslo definované
          v GenericRateAdd a v GenericRateMultiply)

     Tady je příklad z 'etc/speech-dispatcher/modules/epos-generic.conf'
          GenericExecuteSynth \
          "epos-say -o --language $LANG --voice $VOICE --init_f $PITCH --init_t $RATE \
          \"$DATA\" | sed -e s+unknown.*$++ >/tmp/epos-said.wav && play /tmp/epos-said.wav >/dev/null"

 -- Konfigurace generického modulu: AddVoice "LANGUAGE" "SYMBOLICNAME"
          "NAME"
     AddVoice.

 -- Konfigurace generického modulu: GenericLanguage "iso-code"
          "string-subst"

     Definuje, jaký řetězec 'string-subst' by měl být nahrazen za
     '$LANG' pro daný 'iso-code' ISO kód jazyka.

     Opět příklad z Epos generic:
          GenericLanguage "en" "english"
          GenericLanguage "cs" "czech"
          GenericLanguage "sk" "slovak"

 -- Konfigurace generického modulu: GenericRateAdd NUM
 -- Konfigurace generického modulu: GenericRateMultiply NUM
 -- Konfigurace generického modulu: GenericPitchAdd NUM
 -- Konfigurace generického modulu: GenericPitchMultiply NUM
     Tyto parametry nastavují konverzi pro výpočet rychlosti a výšky.
     ('$RATE' a '$PITCH').

     Výsledná rychlost (nebo výška) je dána následujícím vzorcem:
             (speechd_rate * GenericRateMultiply) + GenericRateAdd
     kde speechd_rate je hodnota mezi -100 (nejnižší) a +100 (nejvyšší).
     Je třeba definovat nějakou rozumnou konverzi pro daný syntetizér.

     (Hodnoty v GenericNěcoMultiply jsou vynásobeny stem, protože
     stávající verze DotConfu nepodporuje desetinná čísla.  Můžete tedy
     psát 0.85 jako 85 atd.)

2.3.4 Úrovně logování
---------------------

Ve Speech Dispatcheru je 6 různých úrovní logování.  0 znamená žádné
logování, zatímco 5 znamená vypisovat téměř všechny dostupné informace.

   * Úroveň 0
        * Žádné informace

   * Úroveň 1
        * Informace o startu a vypínání.

   * Úroveň 2
        * Informace o chybách, které nastaly.
        * Alokace a uvolňování zdrojů při startu a při exitu.

   * Úroveň 3
        * Informace o přijímání/odepírání/zavírání klientských spojení.
        * Informace o neplatných SSIP příkazech od klientů.

   * Úroveň 4
        * Je vypisován každý přijatý příkaz
        * Informace o zpracovávání vstupu
        * Informace o ukládání zpráv do front
        * Informace o fungování historie, zvukových ikon, atd.
          facilities.
        * Informace o práci vlákna speak()

   * Úroveň 5 (Ta slouží pouze pro ladící účely a může vypisovat opravdu
     *mnoho* dat.  Používejte opatrně.)
        * Všechna obdržená data jsou vypisována (zprávy od klientů)
        * Ladící informace.

Appendix A Standardní hlasy
***************************

'MALE1'
'MALE2'
'MALE3'
'FEMALE1'
'FEMALE2'
'FEMALE3'
'CHILD_MALE'
'CHILD_FEMALE'

   Skutečná dostupnost těchto hlasů není zaručena, ale příkaz 'SET SELF
VOICE' musí akceptovat jakýkoliv z nich.  Pokud není daný hlas dostupný,
je mapován na jiný hlas výstupním modulem.

Appendix B GNU General Public License
*************************************

                         Version 2, June 1991

     Copyright (C) 1989, 1991 Free Software Foundation, Inc.
     51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

Preamble
========

The licenses for most software are designed to take away your freedom to
share and change it.  By contrast, the GNU General Public License is
intended to guarantee your freedom to share and change free software--to
make sure the software is free for all its users.  This General Public
License applies to most of the Free Software Foundation's software and
to any other program whose authors commit to using it.  (Some other Free
Software Foundation software is covered by the GNU Library General
Public License instead.)  You can apply it to your programs, too.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it if
you want it, that you can change the software or use pieces of it in new
free programs; and that you know you can do these things.

   To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

   For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

   We protect your rights with two steps: (1) copyright the software,
and (2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

   Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

   Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

   The precise terms and conditions for copying, distribution and
modification follow.

    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. This License applies to any program or other work which contains a
     notice placed by the copyright holder saying it may be distributed
     under the terms of this General Public License.  The "Program,"
     below, refers to any such program or work, and a "work based on the
     Program" means either the Program or any derivative work under
     copyright law: that is to say, a work containing the Program or a
     portion of it, either verbatim or with modifications and/or
     translated into another language.  (Hereinafter, translation is
     included without limitation in the term "modification.")  Each
     licensee is addressed as "you."

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running the Program is not restricted, and the output from the
     Program is covered only if its contents constitute a work based on
     the Program (independent of having been made by running the
     Program).  Whether that is true depends on what the Program does.

  1. You may copy and distribute verbatim copies of the Program's source
     code as you receive it, in any medium, provided that you
     conspicuously and appropriately publish on each copy an appropriate
     copyright notice and disclaimer of warranty; keep intact all the
     notices that refer to this License and to the absence of any
     warranty; and give any other recipients of the Program a copy of
     this License along with the Program.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  2. You may modify your copy or copies of the Program or any portion of
     it, thus forming a work based on the Program, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. You must cause the modified files to carry prominent notices
          stating that you changed the files and the date of any change.

       b. You must cause any work that you distribute or publish, that
          in whole or in part contains or is derived from the Program or
          any part thereof, to be licensed as a whole at no charge to
          all third parties under the terms of this License.

       c. If the modified program normally reads commands interactively
          when run, you must cause it, when started running for such
          interactive use in the most ordinary way, to print or display
          an announcement including an appropriate copyright notice and
          a notice that there is no warranty (or else, saying that you
          provide a warranty) and that users may redistribute the
          program under these conditions, and telling the user how to
          view a copy of this License.  (Exception: if the Program
          itself is interactive but does not normally print such an
          announcement, your work based on the Program is not required
          to print an announcement.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Program, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not apply
     to those sections when you distribute them as separate works.  But
     when you distribute the same sections as part of a whole which is a
     work based on the Program, the distribution of the whole must be on
     the terms of this License, whose permissions for other licensees
     extend to the entire whole, and thus to each and every part
     regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Program.

     In addition, mere aggregation of another work not based on the
     Program with the Program (or with a work based on the Program) on a
     volume of a storage or distribution medium does not bring the other
     work under the scope of this License.

  3. You may copy and distribute the Program (or a work based on it,
     under Section 2) in object code or executable form under the terms
     of Sections 1 and 2 above provided that you also do one of the
     following:

       a. Accompany it with the complete corresponding machine-readable
          source code, which must be distributed under the terms of
          Sections 1 and 2 above on a medium customarily used for
          software interchange; or,

       b. Accompany it with a written offer, valid for at least three
          years, to give any third party, for a charge no more than your
          cost of physically performing source distribution, a complete
          machine-readable copy of the corresponding source code, to be
          distributed under the terms of Sections 1 and 2 above on a
          medium customarily used for software interchange; or,

       c. Accompany it with the information you received as to the offer
          to distribute corresponding source code.  (This alternative is
          allowed only for noncommercial distribution and only if you
          received the program in object code or executable form with
          such an offer, in accord with Subsection b above.)

     The source code for a work means the preferred form of the work for
     making modifications to it.  For an executable work, complete
     source code means all the source code for all modules it contains,
     plus any associated interface definition files, plus the scripts
     used to control compilation and installation of the executable.
     However, as a special exception, the source code distributed need
     not include anything that is normally distributed (in either source
     or binary form) with the major components (compiler, kernel, and so
     on) of the operating system on which the executable runs, unless
     that component itself accompanies the executable.

     If distribution of executable or object code is made by offering
     access to copy from a designated place, then offering equivalent
     access to copy the source code from the same place counts as
     distribution of the source code, even though third parties are not
     compelled to copy the source along with the object code.

  4. You may not copy, modify, sublicense, or distribute the Program
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense or distribute the Program is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses terminated
     so long as such parties remain in full compliance.

  5. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Program or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Program (or any work
     based on the Program), you indicate your acceptance of this License
     to do so, and all its terms and conditions for copying,
     distributing or modifying the Program or works based on it.

  6. Each time you redistribute the Program (or any work based on the
     Program), the recipient automatically receives a license from the
     original licensor to copy, distribute or modify the Program subject
     to these terms and conditions.  You may not impose any further
     restrictions on the recipients' exercise of the rights granted
     herein.  You are not responsible for enforcing compliance by third
     parties to this License.

  7. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Program at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Program by all those who receive
     copies directly or indirectly through you, then the only way you
     could satisfy both it and this License would be to refrain entirely
     from distribution of the Program.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system, which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  8. If the distribution and/or use of the Program is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Program under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

  9. The Free Software Foundation may publish revised and/or new
     versions of the General Public License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies a version number of this License which applies to
     it and "any later version," you have the option of following the
     terms and conditions either of that version or of any later version
     published by the Free Software Foundation.  If the Program does not
     specify a version number of this License, you may choose any
     version ever published by the Free Software Foundation.

  10. If you wish to incorporate parts of the Program into other free
     programs whose distribution conditions are different, write to the
     author to ask for permission.  For software which is copyrighted by
     the Free Software Foundation, write to the Free Software
     Foundation; we sometimes make exceptions for this.  Our decision
     will be guided by the two goals of preserving the free status of
     all derivatives of our free software and of promoting the sharing
     and reuse of software generally.

                              NO WARRANTY

  a. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS
     AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
     OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
     LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND
     PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
     DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR
     OR CORRECTION.

  b. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
     OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

                      END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least the
"copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) 19YY  NAME OF AUTHOR

     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License along
     with this program; if not, write to the Free Software Foundation, Inc.,
     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

   Also add information on how to contact you by electronic and paper
mail.

   If the program is interactive, make it output a short notice like
this when it starts in an interactive mode:

     Gnomovision version 69, Copyright (C) 20YY NAME OF AUTHOR
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
     type `show w'.  This is free software, and you are welcome
     to redistribute it under certain conditions; type `show c'
     for details.

   The hypothetical commands 'show w' and 'show c' should show the
appropriate parts of the General Public License.  Of course, the
commands you use may be called something other than 'show w' and 'show
c'; they could even be mouse-clicks or menu items--whatever suits your
program.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a "copyright disclaimer" for the program,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright
     interest in the program `Gnomovision'
     (which makes passes at compilers) written
     by James Hacker.

     SIGNATURE OF TY COON, 1 April 1989
     Ty Coon, President of Vice

   This General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Library General Public License instead of this License.

Appendix C GNU Free Documentation License
*****************************************

                      Version 1.2, November 2002

     Copyright (C) 2000,2001,2002 Free Software Foundation, Inc.
     51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document "free" in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.  We
     recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it can
     be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     "Document", below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as "you".  You accept
     the license if you copy, modify or distribute the work in a way
     requiring permission under copyright law.

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document's overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in the
     notice that says that the Document is released under this License.
     If a section does not fit the above definition of Secondary then it
     is not allowed to be designated as Invariant.  The Document may
     contain zero Invariant Sections.  If the Document does not identify
     any Invariant Sections then there are none.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images composed
     of pixels) generic paint programs or (for drawings) some widely
     available drawing editor, and that is suitable for input to text
     formatters or for automatic translation to a variety of formats
     suitable for input to text formatters.  A copy made in an otherwise
     Transparent file format whose markup, or absence of markup, has
     been arranged to thwart or discourage subsequent modification by
     readers is not Transparent.  An image format is not Transparent if
     used for any substantial amount of text.  A copy that is not
     "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and standard-conforming
     simple HTML, PostScript or PDF designed for human modification.
     Examples of transparent image formats include PNG, XCF and JPG.
     Opaque formats include proprietary formats that can be read and
     edited only by proprietary word processors, SGML or XML for which
     the DTD and/or processing tools are not generally available, and
     the machine-generated HTML, PostScript or PDF produced by some word
     processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

     A section "Entitled XYZ" means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     "Acknowledgements", "Dedications", "Endorsements", or "History".)
     To "Preserve the Title" of such a section when you modify the
     Document means that it remains a section "Entitled XYZ" according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow the
     conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document's license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the title
     equally prominent and visible.  You may add other material on the
     covers in addition.  Copying with changes limited to the covers, as
     long as they preserve the title of the Document and satisfy these
     conditions, can be treated as verbatim copying in other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a machine-readable
     Transparent copy along with each Opaque copy, or state in or with
     each Opaque copy a computer-network location from which the general
     network-using public has access to download using public-standard
     network protocols a complete Transparent copy of the Document, free
     of added material.  If you use the latter option, you must take
     reasonably prudent steps, when you begin distribution of Opaque
     copies in quantity, to ensure that this Transparent copy will
     remain thus accessible at the stated location until at least one
     year after the last time you distribute an Opaque copy (directly or
     through your agents or retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of copies,
     to give them a chance to provide you with an updated version of the
     Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with the
     Modified Version filling the role of the Document, thus licensing
     distribution and modification of the Modified Version to whoever
     possesses a copy of it.  In addition, you must do these things in
     the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of previous
          versions (which should, if there were any, be listed in the
          History section of the Document).  You may use the same title
          as a previous version if the original publisher of that
          version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled "History", Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on the
          Title Page.  If there is no section Entitled "History" in the
          Document, create one stating the title, year, authors, and
          publisher of the Document as given on its Title Page, then add
          an item describing the Modified Version as stated in the
          previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in the
          "History" section.  You may omit a network location for a work
          that was published at least four years before the Document
          itself, or if the original publisher of the version it refers
          to gives permission.

       K. For any section Entitled "Acknowledgements" or "Dedications",
          Preserve the Title of the section, and preserve in the section
          all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document, unaltered
          in their text and in their titles.  Section numbers or the
          equivalent are not considered part of the section titles.

       M. Delete any section Entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          "Endorsements" or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option designate
     some or all of these sections as invariant.  To do this, add their
     titles to the list of Invariant Sections in the Modified Version's
     license notice.  These titles must be distinct from any other
     section titles.

     You may add a section Entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end of
     the list of Cover Texts in the Modified Version.  Only one passage
     of Front-Cover Text and one of Back-Cover Text may be added by (or
     through arrangements made by) any one entity.  If the Document
     already includes a cover text for the same cover, previously added
     by you or by arrangement made by the same entity you are acting on
     behalf of, you may not add another; but you may replace the old
     one, on explicit permission from the previous publisher that added
     the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination all
     of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     "History" in the various original documents, forming one section
     Entitled "History"; likewise combine any sections Entitled
     "Acknowledgements", and any sections Entitled "Dedications".  You
     must delete all sections Entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the documents
     in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow this
     License in all other respects regarding verbatim copying of that
     document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of a
     storage or distribution medium, is called an "aggregate" if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation's users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document's Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled "Acknowledgements",
     "Dedications", or "History", the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided for under this License.  Any other
     attempt to copy, modify, sublicense or distribute the Document is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses terminated
     so long as such parties remain in full compliance.

  10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     <http://www.gnu.org/copyleft/>.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If the
     Document does not specify a version number of this License, you may
     choose any version ever published (not as a draft) by the Free
     Software Foundation.

C.1 ADDENDUM: How to use this License for your documents
========================================================

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.2
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts.
       A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the "with...Texts."  line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of free
software license, such as the GNU General Public License, to permit
their use in free software.